# -*- coding: utf-8 -*-
import os
import math
import re
from scipy.stats         import scoreatpercentile,gmean
from scipy               import mean
from numpy               import *
from glob                import glob
global ia
import pyfits as pf
import numpy as np
from taskinit import *
from imstat_cli import imstat_cli as imstat
from astropy.io import fits

#def newtask(myinput = None):

#    casalog.origin('newtask')
#    casalog.post('Remember to '+myinput)



def AKF(imName, kwdlist, outfile, include):
	if not imName:
           print "Please, specify an image name with the entire path"
           return
	#if not kwdlist:
        #    print "Please, specify the list of keywords to be calculated"
        #    return
	#self.GetImagesInfo(imName)  
	allowed_kw = ['KBNDRES', 'KBNDWID', 'KBNDCTR', 'KDATAMAX', 'KDATAMIN', 'KCHNRMS', 'KSPATRES', 'KSTOKES', 'KDYNRNG', 'KFLUXTOT', 'KDECTARG', 'KRATARG', 'KUVRANGE', 'KDATEEND', 'KDATEOBS','KDATEAVG', 'KMJDAVG', 'KMJDOBS','KMJDEND', 'KNANT', 'KPADLIST', 'KBAND', 'KMAXANGS', 'KMINPRBL', 'KMAXPRBL']

	print 'Given kwds'+ ' : ' + str(kwdlist) 
	print 'Given image'+ ' : ' + imName
	print 'Allowed kwds' + ' : ' + str(allowed_kw)
	if not outfile:
		print "No disk file will be written. Results will be shown on the terminal."
	
	if not include or include == False:
		print "No keywords will be added to the FITS header."
	
	if include == True:
		print "The selected keywords will be added to the FITS header."

	#if len(kwdlist) != 0 and (len(kwdlist)==1 and kwdlist[0] != ''):
	if len(kwdlist) != 0:
	   for kw in kwdlist:
		if str(kw) not in allowed_kw:
			print "Please check the keyword list. One or more keywords are not among those provided by the code" 
			print (str(kw) + ' is not in the list of available keywords.')
			casalog.post("Please check the keyword list. One or more keywords are not among those provided by the code.")
			casalog.post(str(kw) + ' is not in the list of available keywords.')
	else:
	
	  	kwdlist = allowed_kw 
	   	print "All allowed kwds will be calculated"
		casalog.post("All allowed kwds will be calculated")
        

        ImageInstance=ArchiveInfo(imName, kwdlist, outfile, include)

	kwdDict=ImageInstance.Metadata.copy()

	casalog.origin('AKF')
        casalog.post("Input parameters:")
   	if imName: casalog.post("imName = "+imName)
   	if kwdlist: casalog.post("kwdlist = %s" % str(kwdlist))
   	if outfile: casalog.post("outfile = " + outfile)
	if not outfile: casalog.post("No disk file will be written. Results will be shown on the terminal." )
	if not include or include != True: casalog.post("No keywords will be added to the FITS header." )
	if include == True: casalog.post("Keywords will be added to the FITS header." )
	#kwdlistms=['KDECTARG']
	#casalog.post("WARNING:" + str(kwdlistms) + "are not calculated if MS are not given in the same folder." )
	for key, value in sorted(kwdDict.items()):
		if value != None and key in kwdlist:
		  print (str(key) + ' : ' + str(value) + '\n')
                  casalog.post(str(key) +' : '+ str(value) + '\n')
		
	#del ImageInstance
	if include == True:
           for key, value in sorted(kwdDict.items()): 
		if value != None and key in kwdlist:
			 fits.setval(imName,str(key), value= str(value) )
	
	del ImageInstance	

class ArchiveInfo():

   # def __init__(self):
    def __init__(self,imName, kwdlist, outfile, include):
    ### here define global varialbles if needed
        self.Metadata ={}
        self.Metadata['KBNDWID'] = None
        self.Metadata['KBNDRES'] = None
        self.Metadata['KBNDCTR'] = None
        self.Metadata['KSTOKES'] = None
        self.Metadata['KSPATRES'] = None
	self.Metadata['KCHNRMS'] =None
        self.Metadata['KCHNRMS_2'] ={}
	for t in ['I', 'U', 'Q', 'V', 'XX', 'YY']:
		self.Metadata['KCHNRMS_2'][t]= None
	self.Metadata['KDATAMAX'] =None
	self.Metadata['KDATAMAX_2'] ={}
	for t in ['I', 'U', 'Q', 'V', 'XX', 'YY']:
		self.Metadata['KDATAMAX_2'][t]= None
	self.Metadata['KDATAMIN'] =None
	#self.Metadata['KDATAMIN'] ={}
	#for t in ['I', 'U', 'Q', 'V', 'XX', 'YY']:
		#self.Metadata['KDATAMIN'][t]= None
	self.Metadata['KDYNRNG'] =None
	#self.Metadata['KDYNRNG'] ={}
	#for t in ['I', 'U', 'Q', 'V', 'XX', 'YY']:
		#self.Metadata['KDYNRNG'][t]= None
	self.Metadata['KFLUXTOT'] =None
	#self.Metadata['KFLUXTOT'] ={}
	#for t in ['I', 'U', 'Q', 'V', 'XX', 'YY']:
		#self.Metadata['KFLUXTOT'][t]= None
	self.Metadata['KDECTARG'] = None
	self.Metadata['KRATARG'] = None
	self.Metadata['KUVRANGE'] = None
	self.Metadata['KDATEOBS'] = None
	self.Metadata['KDATEEND'] = None
	self.Metadata['KDATEAVG']=None
	self.Metadata['KMJDAVG'] = None
	self.Metadata['KMJDOBS'] = None
	self.Metadata['KMJDEND']=None
	self.Metadata['KNANT'] = None
        #self.Metadata['KNANT'] = {}
	#for a in ['12M', '7M', 'TP']:
		#self.Metadata['KNANT'][a]= None
	self.Metadata['KPADLIST'] = None
	self.Metadata['KBAND'] = None
	self.Metadata['KMAXANGS'] = None
	self.Metadata['KMINPRBL'] = None
	self.Metadata['KMAXPRBL'] = None		
	self.ImageDict={}
        self.msdict={}
        self.mslist= []
	self.path=None
	self.Init(imName, kwdlist, outfile, include)
 
        
    def Init(self,imName, kwdlist, outfile, include):
        
       	self.GetImagesInfo(imName)
	
        for kw in kwdlist:
           
            if kw == 'KBNDRES':
 		     self.BndRes(imName)
            if kw == 'KBNDWID':
                     self.BandWidth(imName)
            if kw == 'KBNDCTR':
                     self.BandCentre(imName)
            if kw == 'KDATAMAX':
                     self.DataMax(imName)
            if kw == 'KDATAMIN':
                     self.DataMin(imName)
            if kw == 'KCHNRMS':
                      self.ChanRmsIm(imName)
            if kw == 'KSPATRES':
                      self.SpatRes(imName)
            if kw == 'KSTOKES':
                     self.GetStokes(imName)
            if kw == 'KDYNRNG':
                     self.Dynamicrange(imName)
            if kw == 'KFLUXTOT':
                     self.GetFluxTot(imName)
            if kw == 'KDECTARG':
                  DECtargMS_p=[]
		  DECtargMS_t=[]
		  if len(self.mslist) != 0:		
			try:
			  for ms in self.mslist:
            			msname = os.path.basename(ms)
				for fieldid in self.msdict[ms]['field_list']:

					DECtargMS=self.DECtargMS(ms, fieldid)
		 			DECtargMS_p.append(DECtargMS)
			  for lst in DECtargMS_p:
             			for dec in lst: 
                 			if dec not in DECtargMS_t:  
                    				DECtargMS_t.append(dec)
        		  self.Metadata['KDECTARG'] = DECtargMS_t
			except:
				print "Warning: KDECTARG could not be calculated as field name is missing in the FITS header"
        	      		casalog.post("Warning: KDECTARG could not be calculated as field name is missing in the FITS header")
		  else:
			print "Warning: KDECTARG will not be calculated as no MS is given"	
    			casalog.post("Warning: KDECTARG will not be calculated as no MS is given")

            if kw == 'KRATARG':
                    RAtargMS_p=[]
		    RAtargMS_t=[]
		    if len(self.mslist) != 0:
			try:
			  for ms in self.mslist:
            			msname = os.path.basename(ms)
            			for fieldid in self.msdict[ms]['field_list']:

					RAtargMS=self.RAtargMS(ms, fieldid)
		 			RAtargMS_p.append(RAtargMS)
			  for lst in RAtargMS_p:
             			for ra in lst: 
                 			if ra not in RAtargMS_t:  
                    				RAtargMS_t.append(ra)
        		  self.Metadata['KRATARG'] = RAtargMS_t
			except:
				print "Warning: KRATARG could not be calculated as field name is missing in the FITS header"
        	      		casalog.post("Warning: KRATARG could not be calculated as field name is missing in the FITS header")
	   	    else:
			print "Warning: KRATARG will not be calculated as no MS is given"	
    			casalog.post("WARNING: KRATARG will not be calculated as no MS is given")

	    if kw == 'KUVRANGE':
		     uv=[]
		     uv_t=[]
		     if len(self.mslist) != 0:	
			try:
			  for ms in self.mslist:
            			msname = os.path.basename(ms)
            			for fieldid in self.msdict[ms]['field_list']:
					uv = self.UVrange(ms, fieldid)
                 			uv_t+=uv
 			  q1_uvdist = scoreatpercentile(uv_t,25)
        		  q2_uvdist = scoreatpercentile(uv_t,50)
        		  q3_uvdist = scoreatpercentile(uv_t,75)
        		  self.Metadata['KUVRANGE']={}
        		  self.Metadata['KUVRANGE']['MEDIAN'] =  q2_uvdist
       			  self.Metadata['KUVRANGE']['Q1'] = q1_uvdist
        		  self.Metadata['KUVRANGE']['Q3'] = q3_uvdist
			except:
				print "Warning: KUVRANGE could not be calculated as field name and/or spw are missing in the FITS header"
        	      		casalog.post("Warning: KUVRANGE could not be calculated as field name and/or spw are missing in the FITS header")
		     else:
			print "Warning: KUVRANGE will not be calculated as no MS is given"	
    			casalog.post("Warning: KUVRANGE will not be calculated as no MS is given")
		
	    if kw == 'KDATEOBS':
		      minMJD_p=[]
		      if len(self.mslist) != 0:	
        		try:
			  for ms in self.mslist:
            			msname = os.path.basename(ms)
            			for fieldid in self.msdict[ms]['field_list']:
                 			
                 			minMJD=self.GetTimes(ms,fieldid)[0]
                 			minMJD_p.append(minMJD)

                 	  mindate=qa.splitdate(str(min(minMJD_p))+'d') 
		 	  minstring="%s-%02d-%02dT%02d:%02d:%05.2f"%(mindate['year'],\
           
        		  mindate['month'],mindate['monthday'],mindate['hour'],mindate['min'],mindate['s'])
        		     		
        	          self.Metadata['KDATEOBS']=minstring
			except:
				print "Warning: KDATEOBS could not be calculated as field name is missing in the FITS header"
        	      		casalog.post("Warning: KDATEOBS could not be calculated as field name is missing in the FITS header")
		      else:
			print "Warning: KDATEOBS will not be calculated as no MS is given"	
    			casalog.post("Warning: KDATEOBS will not be calculated as no MS is given")

	    if kw == 'KDATEAVG':
                                      
                      minMJD_p=[]
                      maxMJD_p=[]
		      if len(self.mslist) != 0:
                        try:
			  for ms in self.mslist:
                                    msname = os.path.basename(ms)
                                    for fieldid in self.msdict[ms]['field_list']:
                                         
                                         minMJD=self.GetTimes(ms,fieldid)[0]
                                         minMJD_p.append(minMJD)
                                         maxMJD=self.GetTimes(ms,fieldid)[1]
                                         maxMJD_p.append(maxMJD) 
 
                          avgMJD=(min(minMJD_p)+max(maxMJD_p))/2.0
                          avgdate=qa.splitdate(str(avgMJD)+'d') 
                          avgstring="%s-%02d-%02dT%02d:%02d:%05.2f"%(avgdate['year'],\
           
                          avgdate['month'],avgdate['monthday'],avgdate['hour'],avgdate['min'],avgdate['s'])
                                        
                          self.Metadata['KDATEAVG']=avgstring
			except:
				print "Warning: KDATEAVG could not be calculated as field name is missing in the FITS header"
        	      		casalog.post("Warning: KDATEAVG could not be calculated as field name is missing in the FITS header")
		      else:
			print "Warning: KDATEAVG will not be calculated as no MS is given"	
    			casalog.post("Warning: KDATEAVG will not be calculated as no MS is given")
		
	    if kw == 'KMJDOBS':
		      	
        	      minMJD_p=[]
                      maxMJD_p=[]
		      if len(self.mslist) != 0:	
        		try:
			  for ms in self.mslist:
            			msname = os.path.basename(ms)
            			for fieldid in self.msdict[ms]['field_list']:
                 			
                 			minMJD=self.GetTimes(ms,fieldid)[0]
                 			minMJD_p.append(minMJD)
                 	
		 	  self.Metadata['KMJDOBS']=min(minMJD_p)
			except:
				print "Warning: KMJDOBS could not be calculated as field name is missing in the FITS header"
        	      		casalog.post("Warning: KMJDOBS could not be calculated as field name is missing in the FITS header")
        	      else:
			print "Warning: KMJDOBS will not be calculated as no MS is given"	
    			casalog.post("Warning: KMJDOBS will not be calculated as no MS is given")	

	    if kw == 'KMJDAVG':
		      
        	      minMJD_p=[]
        	      maxMJD_p=[]
		      if len(self.mslist) != 0:	
		      	try:
        		  for ms in self.mslist:
            			msname = os.path.basename(ms)
            			
				for fieldid in self.msdict[ms]['field_list']:
                 			
                 			minMJD=self.GetTimes(ms,fieldid)[0]
                 			minMJD_p.append(minMJD)
                 			maxMJD=self.GetTimes(ms,fieldid)[1]
                			maxMJD_p.append(maxMJD) 
 				
        		  self.Metadata['KMJDAVG']=(min(minMJD_p)+max(maxMJD_p))/2.0
        		except:
				print "Warning: KMJDAVG could not be calculated as field name is missing in the FITS header"
        	      		casalog.post("Warning: KMJDAVG could not be calculated as field name is missing in the FITS header")
		      else:
			print "Warning: KMJDAVG will not be calculated as no MS is given"	
    			casalog.post("Warning: KMJDAVG will not be calculated as no MS is given")	
	    
	    if kw == 'KMJDEND':
                
      
                      maxMJD_p=[]
		      if len(self.mslist) != 0:
                        try:
			  for ms in self.mslist:
                                    msname = os.path.basename(ms)
                                    for fieldid in self.msdict[ms]['field_list']:
                                         
                                        maxMJD=self.GetTimes(ms,fieldid)[1]
                                        maxMJD_p.append(maxMJD) 
 
                          self.Metadata['KMJDEND']=max(maxMJD_p)
			except:
				print "Warning: KMJDEND could not be calculated as field name is missing in the FITS header"
        	      		casalog.post("Warning: KMJDEND could not be calculated as field name is missing in the FITS header")
		      else:
			print "Warning: KMJDEND will not be calculated as no MS is given"	
    			casalog.post("Warning: KMJDEND will not be calculated as no MS is given")	

         
	    if kw == 'KDATEEND':
		      maxMJD_p=[]
		      if len(self.mslist) != 0:	
			try:
	
        		  for ms in self.mslist:
            			msname = os.path.basename(ms)

            			for fieldid in self.msdict[ms]['field_list']:

                 			maxMJD=self.GetTimes(ms,fieldid)[1]

                			maxMJD_p.append(maxMJD) 
					
 
		 	  maxdate=qa.splitdate(str(max(maxMJD_p))+'d')
        		
        		  maxstring="%s-%02d-%02dT%02d:%02d:%05.2f"%(maxdate['year'],\
           
       			  maxdate['month'],maxdate['monthday'],maxdate['hour'],maxdate['min'],maxdate['s'])
  
        		  self.Metadata['KDATEEND']=maxstring

			except:
				print "Warning: KDATEEND could not be calculated as field name is missing in the FITS header"
        	      		casalog.post("Warning: KDATEEND could not be calculated as field name is missing in the FITS header")
		      else:
			print "Warning: KDATEEND will not be calculated as no MS is given"	
			casalog.post("Warning: KDATEEND will not be calculated as no MS is given")

	    if kw == 'KNANT':
                      NAnts_m=[]
        	      NAnts_p=[]
        	      NAnts_t=[]
		      knant={}
		      keys= ['12M','7M','TP' ]
		      for k in keys:
			    knant[k]=None
		      if len(self.mslist) != 0:	
			try:
			  for ms in self.mslist:
           			msname = os.path.basename(ms)
            			for fieldid in self.msdict[ms]['field_list']:
                 			
                                 	NAnts = self.NumberOfAntennas(ms, fieldid)
                 			NAnts_p.append(NAnts)
			  AntennaType={}
        		  NAnts_t={}
			 	
        		  keylist=NAnts_p[0].keys()
        		  for key in keylist:
            			AntennaType[key]=[]
        		  for d in NAnts_p:
            			for key in d.keys():
                			AntennaType[key].append(d[key][0])
        		  for key in keylist:
                		NAnts_t[key]=[np.max(np.array(AntennaType[key]))]
       			  knant['12M']= NAnts_t['D']
			  knant['7M']= NAnts_t['C']
			  knant['TP']= NAnts_t['P']
			  self.Metadata['KNANT']= str(knant)
			  print type(self.Metadata['KNANT']), self.Metadata['KNANT']
			  #self.Metadata['KNANT']['12M']= NAnts_t['D']
			  #self.Metadata['KNANT']['7M']= NAnts_t['C']
			  #self.Metadata['KNANT']['TP']= NAnts_t['P']
			  

			  
			except:
				print "Warning: KNANT could not be calculated as field name is missing in the FITS header"
        	      		casalog.post("Warning: KNANT could not be calculated as field name is missing in the FITS header")
		      else:
			print "Warning: KNANT will not be calculated as no MS is given"	
			casalog.post("Warning: KNANT will not be calculated as no MS is given")	

	    if kw == 'KPADLIST':
                      padlist_t=[]
        	      padlist_p=[]
		      if len(self.mslist) != 0:	
			try:
			  for ms in self.mslist:
            			msname = os.path.basename(ms)
            			for fieldid in self.msdict[ms]['field_list']:

                                 	padlist = self.ListOfPads(ms, fieldid)
                 			padlist_p.append(padlist)
			  for lst in padlist_p:
             			for pad in lst: 
                 			if pad not in padlist_t:  
                    				padlist_t.append(pad)
        		  self.Metadata['KPADLIST'] = padlist_t
			except:
				print "Warning: kPASLIST could not be calculated as field name is missing in the FITS header"
        	      		casalog.post("Warning: KPADLIST could not be calculated as field name is missing in the FITS header")
		      else:
			print "Warning: KPADLIST will not be calculated as no MS is given"	
			casalog.post("Warning: KPADLIST will not be calculated as no MS is given")	

	    if kw == 'KBAND':
                      receiverBand_t=[]
        	      receiverBand_p=[]
		      if len(self.mslist) != 0:	
			try:
			  for ms in self.mslist:
            			msname = os.path.basename(ms)
            			for fieldid in self.msdict[ms]['field_list']:
                 			                 
                 			receiverBand = self.ObservingBandFromMS(ms, fieldid)
                 			receiverBand_p.append(receiverBand)
			  for lst in receiverBand_p:
                 		for band in lst:
                			if band not in receiverBand_t:
                   				receiverBand_t.append(band)
        		  self.Metadata['KBAND'] = receiverBand_t
			except:
				print "Warning: kINSTRM could not be calculated as field name is missing in the FITS header"
        	      		casalog.post("Warning: KBAND could not be calculated as field name is missing in the FITS header")
		      else:
			print "Warning: KBAND will not be calculated as no MS is given"	
			casalog.post("Warning: KBAND will not be calculated as no MS is given")

	    if kw == 'KMAXANGS':

                      #if not 'KBNDCTR' in self.Metadata.keys():
            			#nu=self.BandCentre(imName)

		     
		      nu = self.BandCentre(imName)

        	      uv=[]
		      uv_t=[]
		      if len(self.mslist) != 0:	
			try:
			  for ms in self.mslist:
            			msname = os.path.basename(ms)
            			for fieldid in self.msdict[ms]['field_list']:
					uv = self.UVrange(ms, fieldid)
                 			uv_t+=uv
        		  minprbl_t= min(uv_t)
			  theta_max= 37100/((nu*10**-9)* minprbl_t) #in arcsec
			
        		  self.Metadata['KMAXANGS'] = str(round(theta_max,2)) 
			except:
				print "Warning: KMAXANGS could not be calculated as field name and/or spw are missing in the FITS header"
        	      		casalog.post("Warning: KMAXANGS could not be calculated as field name and/or spw are missing in the FITS header")
		      else:
			print "Warning: KMAXANGS will not be calculated as no MS is given"	
			casalog.post("Warning: KMAXANGS will not be calculated as no MS is given")

	    if kw == 'KMINPRBL':
		      uv=[]
		      uv_t=[]
		      if len(self.mslist) != 0:				
			try:
			  for ms in self.mslist:
            			msname = os.path.basename(ms)
            			for fieldid in self.msdict[ms]['field_list']:
					uv = self.UVrange(ms, fieldid)
                 			uv_t+=uv
					
			  minprbl_t=min(uv_t)
 			
        		  self.Metadata['KMINPRBL']= minprbl_t
			except:
				print "Warning: kDMINPRBL could not be calculated as field name is missing in the FITS header"
        	      		casalog.post("Warning: KMINPRBL could not be calculated as field name is missing in the FITS header")
		      else:
			print "Warning: KMINPRBL will not be calculated as no MS is given"	
			casalog.post("Warning: KMINPRBL will not be calculated as no MS is given")

        	
	    if kw == 'KMAXPRBL':
		      uv=[]
		      uv_t=[]
		      if len(self.mslist) != 0:				
			try:
			  for ms in self.mslist:
            			msname = os.path.basename(ms)
            			for fieldid in self.msdict[ms]['field_list']:
					uv = self.UVrange(ms, fieldid)
                 			uv_t+=uv
					
			  maxprbl_t=max(uv_t)
 			
        		  self.Metadata['KMAXPRBL']= maxprbl_t
			except:
				print "Warning: KMAXPRBL could not be calculated as field name is missing in the FITS header"
        	      		casalog.post("Warning: KMAXPRBL could not be calculated as field name is missing in the FITS header")
		      else:
			print "Warning: KMAXPRBL will not be calculated as no MS is given"	
			casalog.post("Warning: KMAXPRBL will not be calculated as no MS is given")
	
       		
	

	if len(outfile) !=0 :    
       		printfile= open(outfile, 'w')
        	for key, value in sorted(self.Metadata.items()):
		   if value != None and key in kwdlist:
            		printfile.write(str(key) + '\t' + str(value) + '\n')

	#if include == True:
		
		#hdul = fits.open(imName)
		#hdr = hdul[0].header
		
		#for key, value in sorted(self.Metadata.items()): 
			
			#hdr.set(str(key), str(value))
		#print(repr(hdr))		

	#    #casalog.post(str(key) + '\t' + str(value) + '\n')
	#    casalog.post(str(key)+":"+ str(value))
        #print self.Metadata
	
   
    def GetMSInfo(self,mslist):

        for ms in mslist:
            msmd.open(ms)
            meanfreq = msmd.meanfreq(0)
            msmd.done()

            tb.open(ms+'/FIELD')

	    try:
	
            	punt = tb.query('NAME=="'+self.ImageDict['field_name']+'"')
            	source_id  = punt.getcol("SOURCE_ID")
            	field_id = punt.rownumbers()
            	field_list = list(field_id)
            	tb.close()
            
            
            	self.msdict[ms]={}
            	self.msdict[ms]['meanfreq'] = meanfreq
            	self.msdict[ms]['source_id'] = source_id 
            	self.msdict[ms]['field_list'] = field_list
	    except:
		print "Warning: some keywords could not be calculated."
		casalog.post("Warning: some keywords could not be calculated." )
      
        return  
	
	
        
    def GetImagesInfo(self,imName):
        
        if not os.path.isfile(imName):
            print 'Please Check Image Path and Name'
            return
        
        self.path = os.path.dirname(imName)
        
        ia.open(imName)
        miscdict= ia.miscinfo()
        ia.close()
        myia = iatool()
        myia.open(imName)
        header = myia.summary(verbose=True)
        statistics= myia.statistics(robust=True)
        myia.close()
                
        ImageDict= {}
        ImageDict['header'] = header
        ImageDict['statistics'] = statistics
	try: 
		ImageDict['field_name'] = miscdict['field']
		ImageDict['spw'] = miscdict['spw']
	except:
		print "Warning: no field_name and/or spw are available. Some keywords could not be calculated" 
		casalog.post("Warning: no field_name and/or spw are available. Some keywords could not be calculated" )
       # ImageDict['field_name'] = miscdict['field']
       # ImageDict['spw'] = miscdict['spw']
        
	self.ImageDict= ImageDict

	self.mslist = glob(self.path+'/*.ms')
        try:
		self.GetMSInfo(self.mslist)
	except:
		print "Warning: some keywords could not be calculated."   
		casalog.post("Warning: some keywords could not be calculated." )

        return 
 

    def BndRes(self,imName):
		# Description: Frequency resolution of the image defined as increment of frequency axis
		# Units: Hz
		# Type: float
		# Notes: overlap with CDEL (Ctype = FREQ)
        
        if  len(self.ImageDict) <1:
            self.GetImagesInfo(imName)
        
        
        bndres=[]
        bndres  = (self.ImageDict['header']['incr'][2])
        self.Metadata['KBNDRES'] = abs(bndres)
                                             
        return

    def BandWidth(self,imName):
    	#Description: the effective bandwidth of the image calculated as the increment in the frequency axis * nchannels
        #Units: Hz
        #Type: float
	
        if len(self.ImageDict.keys())<1:
            self.GetImagesInfo(imName)
        
        
        #band_width = self.ImageDict['header']['incr'][2]*self.ImageDict['header']['perplanebeams']['nChannels']
        band_width = self.ImageDict['header']['incr'][2]*self.ImageDict['header']['shape'][2]
        self.Metadata['KBNDWID'] = abs(band_width)
        
        return


    def BandCentre(self,imName):
        #Description: the center frequency of the image calculated as 1/2(the reference value for the frequency axis * number of channels) .
	#Type: float
	#Units: Hz
	

        if len(self.ImageDict.keys())<1:
            self.GetImagesInfo(imName)
        
        nchans=self.GetNchans()
        #band_centre= self.ImageDict['header']['refval'][2]+self.ImageDict['header']['incr'][2]*self.ImageDict['header']['perplanebeams']['nChannels']/2.
        #band_centre= self.ImageDict['header']['refval'][2]+self.ImageDict['header']['incr'][2]*self.ImageDict['header']['shape'][2]/2
        band_centre= self.ImageDict['header']['refval'][2]+self.ImageDict['header']['incr'][2]*nchans/2
        self.Metadata['KBNDCTR'] = band_centre
        
        return band_centre
   

    def GetStokes(self,imName):
	#Description: list of image Stokes parameters
        #Value: either I or I, Q, U, V
        #Type: character
        #Notes: it does not cope with the case of shape (nstokes) = 2 or 3.#Description: list of image Stokes parameters

     
        if len(self.ImageDict.keys())<1:
            self.GetImagesInfo(imName)
	
	
        nstokes= self.GetNstokes()
	refval= self.ImageDict['header']['refval'][3]
	stokes=[]
	if nstokes == 1 and refval == 1:
	   stokes = ['I']
	elif nstokes == 1 and refval == 2:
	   stokes = ['Q']
	elif nstokes == 1 and refval == 3:
	   stokes = ['U']
	elif nstokes == 1 and refval == 4:
	   stokes = ['V']
	elif nstokes == 1 and refval == -5:
	   stokes = ['XX']
	elif nstokes == 1 and refval == -6:
	   stokes = ['YY']
	elif nstokes == 4:
	   stokes = ['I','Q','U','V']
	
	#Fits coding is:(1,2,3,4: I,Q,U,V), (-1,-2,-3,-4: LL,RR,RL,LR circulars), (-5,-6,-7,-8:XX,YY,XY,YX  linears).
	
        self.Metadata['KSTOKES'] = ','.join(stokes)
        return stokes

       

    def GetNstokes(self):
	#it gives number of stokes
	if self.ImageDict['header']['axisnames'][3]== 'Stokes':
		nstokes = self.ImageDict['header']['shape'][3]

	elif  self.ImageDict['header']['axisnames'][2]== 'Stokes':
		nstokes = self.ImageDict['header']['shape'][2]

	else:
		sys.exit('stokes axis not found')
	
	return nstokes

    def GetNchans(self):
	#it gives number of channels
	if self.ImageDict['header']['axisnames'][2]== 'Frequency':
		nchans = self.ImageDict['header']['shape'][2]

	elif  self.ImageDict['header']['axisnames'][3]== 'Frequency':
		nchans = self.ImageDict['header']['shape'][3]

	else:
		sys.exit('frequency axis not found')
	
	return nchans
    
    def DataMax(self,imName):
	#Description: maximum values in the image
	#Type: float
	#Units: Jy/beam
        #Notes: one value for each polarization is given. In the case of spectral line images, the maximum value among the channels is given
        if len(self.ImageDict.keys())<1:
            self.GetImagesInfo(imName)
        

	tstokes= self.GetStokes(imName)
        nchan = self.GetNchans()
        
     	       
	max_val_stokes=[]
	kdatamax={} 
	for t in tstokes:
		val_list=[]		
		for chan in xrange(nchan):
				s= imstat(imName,chans=str(chan), stokes=t)
				max_val = s['max'][0]
				val_list.append(max_val)
	        		max_val_chan= max(val_list)
				#print max_val, max_val_chan
		max_val_stokes.append(max_val_chan)
		kdatamax[t]= max_val_stokes[-1]
		self.Metadata['KDATAMAX']=str(kdatamax) 
		#self.Metadata['KDATAMAX'][t] = max_val_stokes[-1]
		
 
        return 


    def DataMax_2(self,imName):
	#Description: maximum values in the image
	#Type: float
	#Units: Jy/beam
        #Notes: one value for each polarization is given. In the case of spectral line images, the maximum value among the channels is given
        if len(self.ImageDict.keys())<1:
            self.GetImagesInfo(imName)
        

	tstokes= self.GetStokes(imName)
        nchan = self.GetNchans()
        
     	       
	max_val_stokes=[]
	
	for t in tstokes:
		val_list=[]		
		for chan in xrange(nchan):
				s= imstat(imName,chans=str(chan), stokes=t)
				max_val = s['max'][0]
				val_list.append(max_val)
	        		max_val_chan= max(val_list)
				#print max_val, max_val_chan
		max_val_stokes.append(max_val_chan)
		self.Metadata['KDATAMAX_2'][t] = max_val_stokes[-1]
		#print max_val_stokes, max_val_chan 
 
        return self.Metadata['KDATAMAX_2']
  
    def DataMin(self,imName):
	#Description: minimum values in the image
	#Type: float
	#Units: Jy/beam
        #Notes: one value for each polarization is given. In the case of spectral line images, the maximum value among the channels is given
        if len(self.ImageDict.keys())<1:
            self.GetImagesInfo(imName)
        

	tstokes= self.GetStokes(imName)
        nchan = self.GetNchans()
        kdatamin={}     	       
	min_val_stokes=[]
	
	for t in tstokes:
		val_list=[]		
		for chan in xrange(nchan):
				s= imstat(imName,chans=str(chan), stokes=t)
				min_val = s['min'][0]
				val_list.append(min_val)
	        		min_val_chan= min(val_list)
				
		min_val_stokes.append(min_val_chan)
		kdatamin[t]= min_val_stokes[-1]
	self.Metadata['KDATAMIN'] = str(kdatamin)
		#self.Metadata['KDATAMIN'][t] = min_val_stokes[-1]
		 
        return    


    def ChanRmsIm(self,imName):
		# Description: the inter-quartile range of the pixel values in the image  
		# Units: Jy/beam
		# Type: float
                # Notes: one value for each polarization is given.
        
        if len(self.ImageDict.keys())<1:
            self.GetImagesInfo(imName)
   	
        rms_Im_stokes =[]
	kchanrms={}
	tstokes= self.GetStokes(imName)	
		
	for t in tstokes: 
		s=imstat(imagename= imName, stokes =  t)
 		rms_Im_stokes.append(s['quartile'][0])
		kchanrms[t]=rms_Im_stokes[-1]
		self.Metadata['KCHNRMS']= str(kchanrms)
		#self.Metadata['KCHNRMS'][t]= rms_Im_stokes[-1]
                                    
        return

    def ChanRmsIm_2(self,imName):
		# Description: the inter-quartile range of the pixel values in the image  
		# Units: Jy/beam
		# Type: float
                # Notes: one value for each polarization is given.
        
        if len(self.ImageDict.keys())<1:
            self.GetImagesInfo(imName)
   	
        rms_Im_stokes =[]

	tstokes= self.GetStokes(imName)	
		
	for t in tstokes: 
		s=imstat(imagename= imName, stokes =  t)
 		rms_Im_stokes.append(s['quartile'][0])
		
		self.Metadata['KCHNRMS_2'][t]= rms_Im_stokes[-1]
                                    
        return self.Metadata['KCHNRMS_2'] 
      
    def SpatRes(self,imName):
        #Description: geometric average of the min and the max beam axes. For spectral line data, it loops over the channel axis, takes the mean of bmin and bmax among all channel values and then it calculates the geometric average of bmin and bmax.
	#units: arcsecond
	#Type: float

        if len(self.ImageDict.keys())<1:
            self.GetImagesInfo(imName)
        
        xaxis = []
        yaxis = []
        
        nchan = self.GetNchans()
  	nstokes= self.GetNstokes()
	
        try:
		xaxis.append(self.ImageDict['header']['restoringbeam']['major']['value'])
                yaxis.append(self.ImageDict['header']['restoringbeam']['minor']['value'])

	except KeyError:
        	for chan in self.ImageDict['header']['perplanebeams']['beams'].keys():
        	     for stokes in self.ImageDict['header']['perplanebeams']['beams'][chan].keys():
        	            xaxis.append(self.ImageDict['header']['perplanebeams']['beams'][chan][stokes]['major']['value'])
        	            yaxis.append(self.ImageDict['header']['perplanebeams']['beams'][chan][stokes]['minor']['value'])
        
	
        x_mean = mean(xaxis)
        y_mean = mean(yaxis)
        beam= [x_mean,y_mean]
        spatres = gmean(beam)
        self.Metadata['KSPATRES'] = str(round(spatres,2))
        
        return
  


    def Dynamicrange(self,imName):
        #Description: Estimation of image dynamic range for each stoke defined as DATA MAX / CHANRMS
        #type: float 
        #Notes: one value for each polarization is given

        if len(self.ImageDict.keys())<1:
            self.GetImagesInfo(imName)


	datamax=self.DataMax_2(imName)
	chanrms=self.ChanRmsIm_2(imName)
       
        dyn_list=[]
	kdynrng={}
        tstokes= self.GetStokes(imName)
	for t in tstokes:
		datamax_t=datamax[t]
		chanrms_t=chanrms[t]
		dyn = datamax_t/chanrms_t
		dyn_list.append(dyn)
		kdynrng[t]=dyn_list[-1]
		self.Metadata['KDYNRNG']= str(kdynrng)
		#self.Metadata['KDYNRNG'][t] = dyn_list[-1]
        
        return  


    def masked_image(self, imName):

	if len(self.ImageDict.keys())<1:
            self.GetImagesInfo(imName)
	
	f = pf.open(imName)
	tstokes= self.GetStokes(imName)
	#os.system('cp -r '+os.path.join(path,imName)+' '+os.path.join(path, 'copy_'+imName))
	imName_nopath=imName.replace(self.path+'/', '')
	#try:
	
	rms=self.ChanRmsIm_2(imName)

	for t in tstokes:
		#rms=self.Metadata['CHANRMS'][t]
		rms_t = rms[t]
		
		f[0].data = np.where(f[0].data > 3. * rms_t,f[0].data,np.nan)
		msk=os.path.join(self.path, 'masked_'+imName_nopath)
		pf.writeto(msk,data=f[0].data,header=f[0].header,clobber=True)
	#except TypeError:
		#sys.exit('no masked image created')
 		#pf.writeto(copy_imName,data=f[0].data,header=f[0].header,clobber=ovr)
	        
	return  msk  

    def GetFluxTot(self, imName):
        # Description: integrated flux of the source obtained masking the image below 3 * CHANRMS
        # Units: Jy
        # Type: float
        # Notes: now only working for continuum images
	imstat_c = {}
	imstat_flux={}
	
	flux_stokes =[]
	kfluxtot={}
	msk = self.masked_image(imName)
	nchan=self.GetNchans()	
	#istat_dict = imstat(msk)
	
	tstokes= self.GetStokes(imName)
	for t in tstokes:
		imstat_f_list=[]
		for chan in xrange(nchan):
			imstat_c=imstat(msk, chans= str(chan), stokes=t)
			imstat_f=imstat_c['flux']
			
			if not imstat_f.size == 0:
				imstat_f_list.append(imstat_f)
				flux_chan=sum(imstat_f_list)				
		flux_stokes.append(flux_chan)
		kfluxtot[t] = flux_stokes[-1]
		self.Metadata['KFLUXTOT']=str(kfluxtot)
		#self.Metadata['KFLUXTOT'][t] = flux_stokes[-1]
	#if include == True:
 		#print sorted(self.Metadata['KFLUXTOT'].items())
		#for key, value in sorted(self.Metadata['KFLUXTOT'].items()): 
			 #fits.setval(imName,str(key), value= str(value) )



		
	return
	    
    def GetTimes(self, ms, fieldid):
     
         np.set_printoptions(precision=12)

         tb.open(ms)
         punt=tb.query("FIELD_ID ==" + str(fieldid))
         TimesOnField=punt.getcol('TIME')
         ExpOnField=punt.getcol("EXPOSURE")
         
         tb.close()

         TimeMin=[]
         TimeMax=[]

         TimeMin=min(TimesOnField)
         TimeMax=max(TimesOnField)

         indexMin=np.where(TimesOnField == TimeMin)[0][0]
         indexMax=np.where(TimesOnField == TimeMax)[0][0]

         minMJD=(TimeMin - ExpOnField[indexMin]/2.0) / 86400.
         maxMJD=(TimeMax + ExpOnField[indexMax]/2.0) / 86400.

         return minMJD, maxMJD
  
    def RAtargMS(self, ms, fieldid):
        tb.open(ms+'/FIELD')
        RAtargMS=tb.getcell('REFERENCE_DIR',fieldid)[0]
        tb.close()
        return RAtargMS

    def DECtargMS(self, ms, fieldid):
        tb.open(ms+'/FIELD')
        DECtargMS=tb.getcell('REFERENCE_DIR',fieldid)[1]
        tb.close()
        return DECtargMS


    def MinElevation_unflagged(self, ms, fieldid):
    #not include flag data , however long execution time 
 
        MinEL={'D':[100],'C':[100],'P':[100],'F':[100]}
 
        tb.open(ms+'/ANTENNA')
        antennanames= tb.getcol('NAME')
    
        tb.close()
     
        tb.open(ms)
        unflaggedtimerow=[]
        unflaggedtimeperfield = tb.query("FIELD_ID =="+str(fieldid)+" AND FLAG_ROW== False")
        nameant0=unflaggedtimeperfield.getcol('ANTENNA1')[0]
        nameant1=unflaggedtimeperfield.getcol('ANTENNA2')[1]
        a=antennanames[nameant0][0]
        unflaggedtimeperfield_firstbase = tb.query("FIELD_ID =="+str(fieldid)+" AND FLAG_ROW== False"+" AND ANTENNA1 =="+str(nameant0)+" AND ANTENNA2 =="+str(nameant1))
        unflaggedtimerow =unflaggedtimeperfield_firstbase.rownumbers()
        tb.close()
    
        MinELpointinglist=[] 
        for i in range(0, len(unflaggedtimerow)):
	  msmd.open(ms)
	  dirs = msmd.pointingdirection(unflaggedtimerow[i]) 
	  MinELpointing= dirs['antenna2']['pointingdirection']['m1']['value']*180.0/math.pi
	  if(MinELpointing not in MinELpointinglist):
		if(MinELpointing < MinEL[a]):
	  	  MinEL[a]=MinELpointing
	  	 	
	  MinELpointinglist.append(MinELpointing)
	  MinELpointing= dirs['antenna1']['pointingdirection']['m1']['value']*180.0/math.pi
	  if(MinELpointing not in MinELpointinglist):
		if(MinELpointing < MinEL[a]):
	  	  MinEL[a]=MinELpointing
	  	      
	  MinELpointinglist.append(MinELpointing)
	  
        for key in MinEL.keys():
	  if (MinEL[key]> 90): MinEL[key]=None
	  
        tb.close()
  
        return MinEL

    def ObservingBandFromMS(self, ms, fieldid):
      

      ReceiverBand=[]
 
      tb.open(ms+'/SPECTRAL_WINDOW')
      spwname=tb.getcol('NAME')
  
	  
      band_id=[]
      for i in range(0,len(spwname)):
		m = re.search('ALMA_RB_(.+?)#', spwname[i])		  
		if m:
		  band_id.append(m.group(1))
		else:
		  band_id.append(' ')  
		  
      msmd.open(ms)
      spws = msmd.spwsforfield(fieldid)
     
     
      if (len(spws) == 0):
	 ReceiverBand.append(nan)
      else:
	 spws = [val for val in spws]
	 bandind=[]
	 for i in range(1, len(spws)):
	  	bandind.append(band_id[spws[i]])
         bandvalues=list(set(bandind))
	 for i in range(0,len(bandvalues)):
		ReceiverBand.append('B'+bandvalues[i])
  
      return ReceiverBand 

    def NumberOfAntennas(self, ms, fieldid):
	import math
	AntennaType={'D':[],'C':[],'P':[],'F':[]}
	AntennaList=[]
 
	fraction=0.9999 #( fraction of flagging accepted: 1 means completely flagged 0=completely unflagged)
	for key in AntennaType.keys():
		AntennaType[key].append(0)
	tb.open(ms+'/ANTENNA')
	antennanames= tb.getcol('NAME')
	nants=tb.nrows()
	tb.close()

	tb.open(ms)
	for ant in range(0,nants):
		fractionflaggedperant=0
		totflaggedperant=0
		totunflaggedperant=0
			
		flaggedperant = tb.query("FIELD_ID=="+ str(fieldid)+" AND FLAG_ROW== True AND ANTENNA1 == "+str(ant))
		totflaggedperant=totflaggedperant+flaggedperant.nrows()
	 
		unflaggedperant = tb.query("FIELD_ID=="+ str(fieldid)+" AND FLAG_ROW== False AND ANTENNA1 == "+str(ant))
		totunflaggedperant=totunflaggedperant+unflaggedperant.nrows()
	
		try:
                   fractionflaggedperant= float(totflaggedperant)/float(totflaggedperant+totunflaggedperant)
                except ZeroDivisionError:
                   fractionflaggedperant = 1.
	 
		if (fractionflaggedperant <= fraction):
			if(antennanames[ant] not in AntennaList):
				AntennaList.append(antennanames[ant])
				a=antennanames[ant][0]
				if a in AntennaType.keys():
					AntennaType[a][0]=AntennaType[a][0]+1
             
                fractionflaggedperant=0
        tb.close()

	return AntennaType    


    def ListOfPads(self, ms, fieldid):
  	PadList=[]	
    
  	fraction=0.9999 #( fraction of flagging accepted: 1 means completely flagged 0=completely unflagged)
  	tb.open(ms+'/ANTENNA')
  	nants=tb.nrows()   
  	padnames= tb.getcol('STATION')
        tb.close()

  	tb.open(ms)
  	for ant in range(0,nants):
    	    fractionflaggedperant=0
    	    flaggedperant = tb.query(" FIELD_ID=="+ str(fieldid)+" AND FLAG_ROW== True AND ANTENNA1 == "+str(ant))
    	    unflaggedperant = tb.query(" FIELD_ID=="+ str(fieldid)+" AND FLAG_ROW== False AND ANTENNA1 == "+str(ant))
    	    try:

               fractionflaggedperant= float(flaggedperant.nrows())/float(flaggedperant.nrows()+unflaggedperant.nrows())
            
            except ZeroDivisionError:
               fractionflaggedperant = 1.
    
    	    if(fractionflaggedperant <= fraction):
	       if(padnames[ant] not in PadList):  
		       PadList.append(padnames[ant])
		       fractionflaggedperant=0
      	tb.close()
  	
        return PadList


    def UVrange(self, ms, fieldid):
       
        
        tb.open(ms)
       
	punt = tb.query("FLAG_ROW== False AND FIELD_ID=="+ str(fieldid) + '&& DATA_DESC_ID=='+self.ImageDict['spw'])

        uvw  = punt.getcol("UVW")
        tb.close()
        
        try:
            u = uvw[0]
            v = uvw[1]
	    w = uvw[2]	
        except:
            u = nan
            v = nan
	    w = nan	

        uvdist = list((u**2+v**2+w**2)**0.5)
          
        
        return uvdist

 
#if __name__ == '__main__':    
	#ImageInstance = ArchiveInfo()
